use crate::Point;
use std::ops::Neg;
use num::Integer;

/*
-P
-&P
-&mP
*/

impl<T: Integer + Neg<Output = T>> Neg for Point<T> {
    type Output = Point<T>;
    fn neg(self) -> Self::Output {
        Point::from((-self.x, -self.y))
    }
}

impl<T: Integer + Neg<Output = T> + Copy> Neg for &Point<T> {
    type Output = Point<T>;
    fn neg(self) -> Self::Output {
        Point::from((-self.x, -self.y))
    }
}

impl<T: Integer + Neg<Output = T> + Copy> Neg for &mut Point<T> {
    type Output = Point<T>;
    fn neg(self) -> Self::Output {
        Point::from((-self.x, -self.y))
    }
}
